using System;
using System.Security.Principal;
using System.Web;

namespace Demo.ASPNET.MojeTridy
{
	/// Sealed je z bezpecnostnich duvodu, nechci, aby to nekdo dedil a prepsal
	public sealed class IntranetPrincipal:GenericPrincipal
	{
		public readonly string Manazer;						//nadrizeny uzivatele
		public readonly string Lokalita;					//lokalita, ve ktere pracuje
		public readonly DateTime Vytvoren=DateTime.Now;		//datum a cas vytvoreni objektu
		
		private IntranetPrincipal(IIdentity identity,string[] roles,string manazer, string lokalita):base(identity,roles)
		{
			Manazer=manazer;
			Lokalita=lokalita;
		}

		public static IntranetPrincipal Create(IIdentity id)
		{
			string manazer,lokalita;
			string[] role;
			VyhledejUdaje(id,out role,out manazer,out lokalita);
			return new IntranetPrincipal(id,role,manazer,lokalita);
		}

		private static void VyhledejUdaje(IIdentity id,out string[] role, out string manazer, out string lokalita)
		{
			// Zde by se normalne nacetly udaje z databaze, tohle je jenom demo
			switch(id.Name)
			{
				case @"MJUREKSAMPLE\Administrator":
					role=new string[] {@"HELPDESK\Uzivatele",@"FINANCE\ZadavaniDat"};
					manazer="Josef Vclav Sldek";
					lokalita="Praha";
					break;
				default:
					role=new string[] {@"HELPDESK\Reportovani",@"FINANCE\Manazeri"};
					manazer="Miroslav Sldek";
					lokalita="Homeless";
					break;
			}
		}
	}
}
