using System;
using System.Web;
using System.IO;
using System.Drawing;

namespace Demo.ASPNET.MojeTridy
{
	public class ZmensovaniObrazku: IHttpHandler
	{
		public bool IsReusable
		{
			get
			{
				return true;
			}
		}

		public void ProcessRequest(System.Web.HttpContext context)
		{
			string fullpath=context.Request.PhysicalPath;
			string origpath=Path.GetDirectoryName(fullpath)+"\\"+Path.GetFileNameWithoutExtension(fullpath);
			Bitmap obr=new Bitmap(origpath);
			Size s=VypoctiVelikost(context,obr);
			Image zmens=obr.GetThumbnailImage(s.Width,s.Height,null,IntPtr.Zero);
			// Nastav CachePolicy pro zvyseni vykonu - celkem na 3 hodiny
			VlozDoCache(context,3);
			context.Response.ContentType="image/jpeg";
			zmens.Save(context.Response.OutputStream,System.Drawing.Imaging.ImageFormat.Jpeg);
		}

		private void VlozDoCache(HttpContext context, int pocetHodin)
		{
			HttpCachePolicy cachepol=context.Response.Cache;
			cachepol.VaryByParams["*"]=true;
			cachepol.SetExpires(System.DateTime.Now.AddHours(pocetHodin));
			cachepol.SetCacheability(HttpCacheability.Public);
			cachepol.SetValidUntilExpires(true);
		}

		private Size VypoctiVelikost(HttpContext context, Bitmap obr)
		{
			int sirka, vyska;
			if (context.Request.QueryString["vyska"] != null)
			{
				vyska=Convert.ToInt32(context.Request.QueryString["vyska"]);
				if (context.Request.QueryString["sirka"] != null)
				{
					sirka=Convert.ToInt32(context.Request.QueryString["sirka"]);
				}
				else
				{
					sirka=obr.Width*vyska/obr.Height;
				}
			}
			else
			{
				if (context.Request.QueryString["sirka"] != null)
				{
					sirka=Convert.ToInt32(context.Request.QueryString["sirka"]);
				}
				else
				{
					sirka=120;
				}
				vyska=obr.Height*sirka/obr.Width;
			}
			return new Size(sirka, vyska);
		}
	}
}