using System;
using System.Web;
using System.Web.Mail;
using System.Configuration;
using System.Diagnostics;

namespace Demo.ASPNET.MojeTridy
{
	public class ErrorLogging : IHttpModule
	{
		private string email;
		public void Init(System.Web.HttpApplication context)
		{
			context.Error+=new EventHandler(ZapisDoEventLogu);
			// Pripadna registrace pro odesilani emailu
			if(ConfigurationSettings.AppSettings["WebmasterEmail"]!=null)
			{
				email=ConfigurationSettings.AppSettings["WebMasterEmail"];
				context.Error+=new EventHandler(OdeslaniZpravyEmailem);
			}
		}

		public void Dispose()
		{
		}

		private void ZapisDoEventLogu(Object sender, EventArgs e)
		{
			Exception ex=HttpContext.Current.Server.GetLastError().InnerException;
			string jmenoLogu="ASP.NET Aplikace";
			if(!EventLog.SourceExists(ex.Source))
				EventLog.CreateEventSource(ex.Source,jmenoLogu); //ASPNET musi mit FullControl pristup ke klici registru HKLM\System\CurrentControlSet\Services\EventLog, jinak volani selze
			EventLog mujEventLog = new EventLog();
			mujEventLog.Source = ex.Source;
			mujEventLog.Log=jmenoLogu;
			mujEventLog.WriteEntry(ex.ToString(),EventLogEntryType.Error);
		}

		private void OdeslaniZpravyEmailem(Object sender, EventArgs e)
		{
			MailMessage mm=new MailMessage();
			mm.From="robot@webserver";
			mm.To=email;
			Exception ex=HttpContext.Current.Server.GetLastError().InnerException;
			mm.Subject="Chyba v ASP.NET aplikaci "+ex.Source;
			mm.Priority=MailPriority.High;
			mm.Body=ex.ToString();
			SmtpMail.Send(mm);
		}

	}
}
